 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.Color;
 public class EventType {
	 protected int number;	
	 protected String name;
	 protected Color color;
	 
	 public EventType(int nu, String na, Color co){
		 number=nu;
		 name=na;
		 color=co;	
	 }
	 
	 public int getNumber(){
		 return number;
	 }
	 
	 public String getName(){
		 return name;
	 }
	 
	 public void setName(String na){
		 name=na;	
	 }	
	 
	 public Color getColor(){
		 return color;
	 }	
	 
	 public void setColor(Color co){
		 color=co;		
	 }
	 
	 public void setEventType(int nu, String na, Color co){
		 number=nu;
		 name=na;
		 color=co;	
	 }
 }