 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 
 public class ProjectName extends JDialog    implements ActionListener{
	 protected JLabel jLabel1_project,jLabel1_extension;
	 protected JButton JButton_ok,JButton_cancel;
	 protected JTextField JText_Project;
	 //public String name="newproject",
	 public String oldname="";
	 int returnval;
	 
	 public ProjectName(JFrame pai) {
		 super( pai, "NEW GLASS PROJECT", true);
		 //Center the window
		 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		 Dimension frameSize = this.getSize();
		 if (frameSize.height > screenSize.height) {
			 frameSize.height = screenSize.height;
		 }
		 if (frameSize.width > screenSize.width) {
			 frameSize.width = screenSize.width;
		 }
		 this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
		 
		 //  	name="newproject";
		 getContentPane().setLayout(null);
		 setVisible(false);
		 setSize(330,130);
		 jLabel1_project = new JLabel();
		 jLabel1_project.setBounds(20,10,250,35);
		 jLabel1_project.setText("Project Name");
		 getContentPane().add(jLabel1_project);	
		 jLabel1_extension = new JLabel();
		 jLabel1_extension.setBounds(235,10,250,35);
		 jLabel1_extension.setText(".glass");
		 getContentPane().add(jLabel1_extension);			
		 JText_Project = new JTextField(20);
		 JText_Project.setBounds(114,10,115,30);	
		 JText_Project.setText("newproject");	
		 getContentPane().add(JText_Project);		
		 JButton_ok = new JButton();
		 JButton_ok.setText("OK");
		 JButton_ok.setBounds(80,48,112,32);
		 getContentPane().add(JButton_ok);
		 JButton_ok.addActionListener(this);
		 JButton_cancel = new JButton();
		 JButton_cancel.setText("Cancel");
		 JButton_cancel.setBounds(200,48,112,32);
		 getContentPane().add(JButton_cancel);
		 JButton_cancel.addActionListener(this);
		 validate();
	 }
	 
	 public int New() {
		 oldname=JText_Project.getText();
		 JText_Project.setText("newproject");	
		 returnval=1;	
		 this.show();	
		 return returnval;
	 }	
	 
	 public void setName(String xname) {
		 JText_Project.setText(xname);	
		 //name=xname;	
	 }	
	 
	 public String getName() {
		 return JText_Project.getText();	
	 }	
	 
	 public void actionPerformed(ActionEvent event) {
		 Object source = event.getSource();
		 if ( source == JButton_ok  ) {
			 //name=JText_Project.getText();
			 returnval=0;
		 }
		 else
			 {JText_Project.setText(oldname);	}	
		 this.dispose( );
	 }
	 
	 //void  accept_action()
	 //	{  this.dispose( );}
 }