import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
//import java.io.*;
import java.util.*;
import javax.swing.border.*;
//
import javax.swing.event.*;
/**
 * <p>Title: < Tracer for Glass Application/p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Authors: Marcelo de Paiva and Bruno Barberi Gnecco</p>
 
 * @version 1.0
 */
class MousePanel extends JPanel   
	{ 
  	private Frame1 frm;
  
 	public MousePanel(Frame1 f)
   		{ 
      	frm=f;
      	setPreferredSize(new Dimension(MAX_XWIDTH,     MAX_YHEIGHT));
      	this.setBackground(Color.lightGray);	
   		}

	public void paintComponent(Graphics g)
   		{   		
   		super.paintComponent(g);
   		frm.listFilters.setCellRenderer(new List_Renderer()); 
		int y = 0;
		int i;
        int x;
        boolean xdraw;
        xdraw=true;
        Enumeration e = (frm.msg).elements();
        Message tmp2;
        int xline=50;
        while( e.hasMoreElements() )
			{
		    tmp2 = (Message) e.nextElement();	
		    if (!frm.ListAllMessages) // filter the messages
		    	{
		    	i=0;
		    	xdraw=false;
		    	while (i<frm.FilterValues.length && !xdraw)	
		    	//for (int i=0;i<frm.FilterValues.length;i++)
   					{   	
   					if ((tmp2.getMsg()).equals((String)frm.FilterValues[i])) //apply the filter
   					 	xdraw=true;
   					i++; 	
   					//else
   					//	xdraw=false; 	
   					}	
		    	}	
		    if (xdraw)	
		    	{
         		if (tmp2.getType()=='S') // send
         	    	draw(g,xline,tmp2.getPosition(),tmp2.getMsg(),0);
         		else  
         			draw(g,xline,tmp2.getPosition(),tmp2.getMsg(),1);         			
         		xline=xline+50;  
         		/*JScrollBar scrollBar;
				scrollBar = frm.jScrollPane1.getVerticalScrollBar();
				int increment = scrollBar.getUnitIncrement();
				//scrollBar.setValue(scrollBar.getValue() + increment);
				System.out.println(increment);
				scrollBar.setValue(scrollBar.getValue() + 1);*/
				
         		}
		    }     
        e = (frm.nodes).elements();
        Host tmp;
        while( e.hasMoreElements() )
			{
		    tmp = (Host) e.nextElement();	
         	g.drawLine(y,0,y,xline+100);         	
         	y=y+100; 
		    }  		  	
   		}
public void draw(Graphics g,int l, int p,String m, int d)
   {
   p=p-15;	
   Polygon pol = new Polygon();	
   if (d ==0) // to rigth
   		{
   		g.setColor(new Color(0,0,100));	//blue 
   		pol.addPoint(p,l-5);		
   		pol.addPoint(p+15,l+2);	
   		pol.addPoint(p,l+10);	
   		g.fillRect(0,l,p,5);  
   		}
   	else  // to left
   		{
   		g.setColor(new Color(0,80,0));	// green	
   		pol.addPoint(15,l-5);
   		pol.addPoint(0,l+2);	
   		pol.addPoint(15,l+10);	
  		g.fillRect(15,l,p,5);
   		}

   	g.fillPolygon(pol);
   	g.drawString(m,20 ,l-2); 		   		
   }	
   
   private static final int MAX_XWIDTH = 1600;
   private static final int MAX_YHEIGHT = 100000;
}


public class Frame1 extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JPanel jPanel1 = new JPanel();
  JButton jButtonStart = new JButton();
  JButton jButtonStop = new JButton();
  JButton jButtonResume = new JButton();
  JButton jButtonClean = new JButton(); 
  JButton jButtonExit = new JButton();
  JButton jButtonLog = new JButton();
  JButton jBapply = new JButton();
  boolean ListAllMessages=true; // if is presented (draw) all messagens
  
  Component viewedComponent;// = new MousePanel(this);
  JScrollPane jScrollPane1;// = new JScrollPane(viewedComponent);
  
  public Vector <String> listmsg; // type of messages (for list panel)  
  JPanel jPanel2 = new JPanel();
  TitledBorder titledBorder1;
   JList listFilters;// = new JList(listmsg);
  
  JScrollPane jScrollFilter;// =new JScrollPane(listFilters);
  Object[] FilterValues; // list of filters selecte

  public Vector nodes; //  host vector 
  public Vector msg;   // Message vector

  ReaderLog  readerlog1;
  Thread reader1;
  String xfile=""; // file log
  ViewLog view; 
  //Construct the frame
  
  public Frame1(String xfilename) {
  	viewedComponent = new MousePanel(this);
  	readerlog1 = new ReaderLog(this,xfilename);
  	jScrollPane1 = new JScrollPane(viewedComponent);
  	
  	view = new ViewLog();
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit(xfilename);
      RulerPanel horizRulerPanel = new RulerPanel(SwingConstants.HORIZONTAL,viewedComponent.getPreferredSize().width,25, 100, 100,this);
      jScrollPane1.setColumnHeaderView(horizRulerPanel);

      RulerPanel vertRulerPanel = new RulerPanel(SwingConstants.VERTICAL,30, viewedComponent.getPreferredSize().height,50, 1,this);
      jScrollPane1.setRowHeaderView(vertRulerPanel);
      ScrollAction.register(jScrollPane1, JScrollBar.HORIZONTAL,ScrollAction.UNIT, -1, KeyEvent.VK_LEFT, 0);
      ScrollAction.register(jScrollPane1, JScrollBar.HORIZONTAL,ScrollAction.UNIT, 1, KeyEvent.VK_RIGHT, 0);
      ScrollAction.register(jScrollPane1, JScrollBar.VERTICAL,ScrollAction.UNIT, -1, KeyEvent.VK_UP, 0);
      ScrollAction.register(jScrollPane1, JScrollBar.VERTICAL, ScrollAction.UNIT, 1, KeyEvent.VK_DOWN, 0);
      ScrollAction.register(jScrollPane1, JScrollBar.HORIZONTAL,ScrollAction.BLOCK, -1, KeyEvent.VK_PAGE_UP,InputEvent.CTRL_MASK);
      ScrollAction.register(jScrollPane1, JScrollBar.HORIZONTAL,ScrollAction.BLOCK, 1, KeyEvent.VK_PAGE_DOWN,InputEvent.CTRL_MASK);
      ScrollAction.register(jScrollPane1, JScrollBar.VERTICAL, ScrollAction.BLOCK, -1, KeyEvent.VK_PAGE_UP, 0);
      ScrollAction.register(jScrollPane1, JScrollBar.VERTICAL,ScrollAction.BLOCK, 1, KeyEvent.VK_PAGE_DOWN, 0);
    }
    catch(Exception e) {
      e.printStackTrace();
    }        
  }
  //Component initialization
  private void jbInit(String xfilename) throws Exception  {
  	nodes=new Vector();
  	msg=new Vector();
  	listmsg = new Vector <String>();
  	listmsg.add(new String("All"));
					
  	listFilters = new JList(listmsg);
  	jScrollFilter =new JScrollPane(listFilters);
  	FilterValues =listFilters.getSelectedValues();   
  	nodes.add(new Host(0));	
    contentPane = (JPanel) this.getContentPane();
    titledBorder1 = new TitledBorder("Filter");
    contentPane.setLayout(null);
    this.setSize(new Dimension(700, 550));
    this.setTitle("Glass Tracer  "+xfilename);
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new Frame1_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new Frame1_jMenuHelpAbout_ActionAdapter(this));
    //jPanel1.setBackground(UIManager.getColor("FormattedTextField.inactiveForeground"));
    jPanel1.setBackground(Color.lightGray);
    
    jPanel1.setBounds(new Rectangle(14, 28, 103, 157));
    jPanel1.setLayout(null);
    jButtonStart.setBounds(new Rectangle(11, 15, 86, 25));
    jButtonStart.setAlignmentX((float) 0.5);
    jButtonStart.setAlignmentY((float) 0.5);
    jButtonStart.setMaximumSize(new Dimension(80, 0));
    jButtonStart.setMinimumSize(new Dimension(80, 0));
    jButtonStart.setPreferredSize(new Dimension(81, 0));
    jButtonStart.setText("Start");
    jButtonStart.addActionListener(new Frame1_jButtonStart_actionAdapter(this));
    
    jButtonStop.setBounds(new Rectangle(11, 48, 86, 25));
    jButtonStop.setAlignmentX((float) 0.5);
    jButtonStop.setAlignmentY((float) 0.5);
    jButtonStop.setMaximumSize(new Dimension(80, 0));
    jButtonStop.setMinimumSize(new Dimension(80, 0));
    jButtonStop.setPreferredSize(new Dimension(81, 0));
    jButtonStop.setText("Stop");
    jButtonStop.addActionListener(new Frame1_jButtonStop_actionAdapter(this));
    /*jButtonResume.setBounds(new Rectangle(10, 80, 89, 25));
    jButtonResume.setAlignmentX((float) 0.5);
    jButtonResume.setAlignmentY((float) 0.5);
    jButtonResume.setMaximumSize(new Dimension(80, 0));
    jButtonResume.setMinimumSize(new Dimension(80, 0));
    jButtonResume.setPreferredSize(new Dimension(81, 0));
    jButtonResume.setText("Resume");
    jButtonResume.addActionListener(new Frame1_jButtonResume_actionAdapter(this));
    */
    jButtonClean.setBounds(new Rectangle(11, 80, 87, 25));
    jButtonClean.setAlignmentX((float) 0.5);
    jButtonClean.setAlignmentY((float) 0.5);
    jButtonClean.setMaximumSize(new Dimension(80, 0));
    jButtonClean.setMinimumSize(new Dimension(80, 0));
    jButtonClean.setPreferredSize(new Dimension(81, 0));
    jButtonClean.setText("Clean");
    jButtonClean.addActionListener(new Frame1_jButtonClean_actionAdapter(this));
    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    
    jScrollPane1.setBounds(new Rectangle(132, 26, 530, 425));
    contentPane.setPreferredSize(new Dimension(600, 500));
//    contentPane.setVerifyInputWhenFocusTarget(true);
    //jButtonExit.setBounds(new Rectangle(547, 448, 73, 25));
    jButtonExit.setBounds(new Rectangle(545, 463, 73, 25));
    jButtonExit.setText("Exit");
    jButtonExit.addActionListener(new Frame1_jButtonExit_actionAdapter(this));
    jButtonLog.setBounds(new Rectangle(10, 112, 89, 25));
    jButtonLog.setAlignmentX((float) 0.5);
    jButtonLog.setAlignmentY((float) 0.5);
    jButtonLog.setMaximumSize(new Dimension(80, 0));
    jButtonLog.setMinimumSize(new Dimension(80, 0));
    jButtonLog.setPreferredSize(new Dimension(81, 0));
    jButtonLog.setText("View Log");
    jButtonLog.addActionListener(new Frame1_jButtonLog_actionAdapter(this));
    
    jBapply.setText("Apply");
    jBapply.addActionListener(new Frame1_jBapply_actionAdapter(this));
    
    jPanel2.setBorder(titledBorder1);
//    jPanel2.setBounds(new Rectangle(05, 223, 122, 229));
    jPanel2.setBounds(new Rectangle(14, 195, 104, 269));
    //new Rectangle(13, 223, 104, 229)
    listFilters.setBounds(new Rectangle(05, 223, 122, 199));

    //listFilters.setAlignmentY((float) 0.2);
//    listFilters.setMinimumSize(new Dimension(90, 100));
  //  listFilters.setMaximumSize(new Dimension(90, 100));
    listFilters.setPreferredSize(new Dimension(90, 100));
    listFilters.setVisibleRowCount(7);
    
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    jPanel1.add(jButtonResume, null);
    jPanel1.add(jButtonStop, null);
    jPanel1.add(jButtonClean, null);
    jPanel1.add(jButtonStart, null);
    jPanel1.add(jButtonLog, null);
     contentPane.add(jPanel2, null);
    jPanel2.add(jScrollFilter, null);   
    jPanel2.add(jBapply, null);
    //listFilters.addListSelectionListener(this);
    contentPane.add(jButtonExit, null);
    contentPane.add(jPanel1, null);
    contentPane.add(jScrollPane1, null);
    this.setJMenuBar(jMenuBar1);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
  	this.dispose();
    //System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    TraceAbout dlg = new TraceAbout(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);

    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void jButtonExit_actionPerformed(ActionEvent e) {
  	this.dispose();
    //System.exit(0);
  }
  void jButtonStart_actionPerformed(ActionEvent e) {
      System.out.println("starting");  	    
      reader1 = new Thread(readerlog1);
//      Status=true;
      reader1.setPriority(2);
      readerlog1.setStatus(true);
      reader1.start();
  }

  void jButtonStop_actionPerformed(ActionEvent e) {
  	System.out.println("stop...");  
  	//reader1.stop();
  	readerlog1.setStatus(false);
  	repaint();
//       Status=false;

  }

  /*void jButtonResume_actionPerformed(ActionEvent e) {
    JOptionPane.showMessageDialog(this, "Your project was not save!!","GLASS Tool",JOptionPane.INFORMATION_MESSAGE);
  }
*/
  void jButtonClean_actionPerformed(ActionEvent e) {
      nodes.clear();
      msg.clear();
      listmsg.clear();
      listmsg.add(new String("All"));
      nodes.add(new Host(0));	
	  //FilterValues =listFilters.getSelectedValues();   
	  listFilters.setCellRenderer(new List_Renderer()); 
      xfile="";
      repaint();
  }

  void jButtonLog_actionPerformed(ActionEvent e) {
  	  
  	  view.setText(xfile);
  	  view.show();
  }

void jBapply_actionPerformed(ActionEvent e) 
	{
   	FilterValues =listFilters.getSelectedValues();    
    ListAllMessages=true;
    if (!(FilterValues.length == 0 ||((String)FilterValues[0]).equals("All"))) // All selected   				   	
   		ListAllMessages=false;	
   	repaint();   
  }
  
}

class Frame1_jBapply_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jBapply_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jBapply_actionPerformed(e);
  }
}

class Frame1_jMenuFileExit_ActionAdapter implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuFileExit_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }  
}

class Frame1_jMenuHelpAbout_ActionAdapter implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuHelpAbout_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class Frame1_jButtonExit_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonExit_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonExit_actionPerformed(e);
  }
}

class Frame1_jButtonStart_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonStart_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonStart_actionPerformed(e);
  }
}

class Frame1_jButtonStop_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonStop_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonStop_actionPerformed(e);
  }
}
/*
class Frame1_jButtonResume_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonResume_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonResume_actionPerformed(e);
  }
}
*/
class Frame1_jButtonClean_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonClean_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonClean_actionPerformed(e);
  }
}

class Frame1_jButtonLog_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonLog_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonLog_actionPerformed(e);
  }
  
}  

class ScrollAction extends AbstractAction
	{
	public ScrollAction(JScrollPane p, int orient,int t, int dir)
   		{
   		scrollPane = p;
      	orientation = orient;
      	type = t;
      	direction = dir;
   		}

   public static void register(JScrollPane p, int orient,  int t, int dir, int key, int modifier)
   		{  
   		p.registerKeyboardAction( new ScrollAction(p, orient, t, dir), KeyStroke.getKeyStroke(key, modifier, false),JComponent.WHEN_IN_FOCUSED_WINDOW);
   		}

   public void actionPerformed(ActionEvent evt)
   		{
   		JScrollBar scrollBar;
      	if (orientation == JScrollBar.HORIZONTAL)
        	scrollBar = scrollPane.getHorizontalScrollBar();
      	else
        	scrollBar = scrollPane.getVerticalScrollBar();
      	if (scrollBar == null || !scrollBar.isVisible())
        	return;
      	int increment;
      	if (type == UNIT)
        	increment = scrollBar.getUnitIncrement();
      	else
        	increment = scrollBar.getBlockIncrement();
      		scrollBar.setValue(scrollBar.getValue() + increment * direction);
   		}

   private JScrollPane scrollPane;
   private int orientation; // HORIZONTAL or VERTICAL
   private int type; // UNIT or BLOCK
   private int direction; // +1 or -1
   public static final int UNIT = 1;
   public static final int BLOCK = 2;
}

class RulerPanel extends JPanel implements SwingConstants
	{
	public RulerPanel(int dir, int w, int h,   int lbldist, int lbl,Frame1 f)
   		{
   		direction = dir;
      	labelDistance = lbldist;
      	label = lbl;
      	frm=f;
      	//subdivisions = subs;
      	setPreferredSize(new Dimension(w, h));
   		}

   public void paintComponent(Graphics g)
   		{
   		super.paintComponent(g);
      	Dimension d = getPreferredSize();
      	if (direction == HORIZONTAL)
      		{      		
         	int i = 0;
         	int x = 0;
         	//g.drawLine(0,24,100000,24);
         	//g.drawLine(0,24,10,24);
         	Enumeration e = (frm.nodes).elements();
		    Host tmp;     
		    while( e.hasMoreElements() )
		        {
		  //      g.drawLine(x, 0, x, 100000);
		        g.drawLine(x, 0, x, 25);
		        tmp = (Host) e.nextElement();
		        g.drawString(" Host " + tmp.getId(), x + 2,(d.height * 8) / 10);
		        tmp.setPosition(x);
		        i++;
            	x = i * labelDistance;	
		    	}  
		    g.drawLine(0,24,x+200,24);	  	
      		}
      	else
      		{
      		int i = 0;
         	int y = 0;         	
         	while (y <= d.height)
         		{
         		g.drawLine(0, y, (d.width * 8) / 10, y);
            	g.drawString(" " + i * label, 2, y);
            	i++;
            	y = i * labelDistance;
         		}
      		}
   		}

   private int direction;
   private int labelDistance;
   private int label;
   private Frame1 frm;
}

class List_Renderer extends DefaultListCellRenderer {
  private Hashtable iconTable = new Hashtable();
  
  public Component getListCellRendererComponent(JList list,
                                                Object value,
                                                int index,
                                                boolean isSelected,
                                                boolean hasFocus) {
 super.getListCellRendererComponent(list,
                                                 value,
                                                 index,
                                                 isSelected,
                                                 hasFocus);
    return this;
  }
}

