 /**
  *  Java binding for libGlass
  *  Copyright (C) 2003-2010
  *  Corollarium Technologies
  * 
  *  This library is free software; you can redistribute it and/or
  *  modify it under the terms of the GNU Lesser General Public
  *  License as published by the Free Software Foundation; either
  *  version 2 of the License, or (at your option) any later version.
  *
  *  This library is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  *  Lesser General Public License for more details.
  *
  *  You should have received a copy of the GNU Lesser General Public
  *  License along with this library; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  *  @author      Corollarium Technologies
  *  @version     %I%, %G%
  *  @since       1.0
  */

import Glass.*;

class TestServerPeer {
	public static void main(String[] args) {
		System.out.println("Starting server");
		try{
			int listenport = Integer.parseInt(args[3]);
			int connectport = Integer.parseInt(args[2]);
			GlassServerPeer gs = new GlassServerPeer(new TCP(listenport), args[1], connectport);
		} catch(GlassException e){
			System.out.println("Error: Server initialization: "+e);
		}
	}
}
