 /**
 *   GEditor - a interface generator for PDA Glass application
 * Marcelo de Paiva Guimaraes and Bruno Barberi Gnecco
 * Copyright (C) 2003,2004
 * 
 *  It is part of Glass - a distributed computing library
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  @author      Marcelo de Paiva Guimaraes
 *  @version     %I%, %G%
 *  @since       1.0
 */
 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import javax.swing.event.*;
 import javax.swing.colorchooser.*;
 
 public class Cores extends JDialog implements ActionListener{
	 public final JColorChooser tcc = new JColorChooser(Color.blue);
	 protected JButton  button_ok;
	 
	 public Cores() {
		 tcc.getSelectionModel().addChangeListener(
		 new ChangeListener() {
			 public void stateChanged(ChangeEvent e) {                   
				 
			 }
		 }
		 
		 );
		 tcc.setBorder(BorderFactory.createTitledBorder("Choose the Color"));
		 getContentPane().add(tcc, BorderLayout.CENTER);
		 button_ok = new JButton();
		 button_ok.setText("OK");	
		 button_ok.setBounds(96,48,112,32);
		 getContentPane().add(button_ok,BorderLayout.SOUTH);
		 button_ok.addActionListener(this);
		 pack();
	 }
	 
	 public Color Obter_cor(){
		 return tcc.getColor();
	 }
	 
	 public void actionPerformed(ActionEvent event){
		 Object source = event.getSource();
		 if ( source == button_ok  ){ 	
			 accept_action();
		 }
	 }
	 
	 void  accept_action(){
		 this.dispose( );
	 } 
 }